<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 8                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Modules
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoUpdateModule
 * A function to update a CMS module
 * @author Philipp Louis Esselbach
 */
function AdminDoUpdateModule()
{
	global $database, $security, $preferences, $config, $system, $html, $xml, $words_modules;
	define( "CONTENTTELLER_INSTALL", 1 );
	define( "DEFAULT_LANGUAGE", $security -> localcheckvar( $config[ 'ADMIN_LANGUAGE' ] ) );
	include( "../includes/install.php" );
	define( "INSTALLED_BUILD", $install_build );
	$input_module = ( isset( $_POST[ 'input_module' ] ) ) ? $security -> checkvar( $_POST[ 'input_module' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_modules[ 'ERROR' ], $words_modules[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	if( is_dir( $input_module ) )
	{
		$queries = $system -> getdir( $input_module );
		
		foreach( $queries as $query )
		{
			if( preg_match( "/mysql_upgrade/i", $query ) )
			{
				include( $input_module . "/" . $query );
			}
		}
			
		if( file_exists( $input_module . "/preferences_" . $input_module . "_" . $config[ 'ADMIN_LANGUAGE' ] . ".xml" ) )
		{
			$xml -> importperfs( $input_module . "/preferences_" . $input_module . "_" . $config[ 'ADMIN_LANGUAGE' ] . ".xml" );
		}
		elseif( file_exists( $input_module . "/preferences_" . $input_module . "_en.xml" ) )
		{
			$xml -> importperfs( $input_module . "/preferences_" . $input_module . "_en.xml" );
		}
		
		$query = $database -> dbquery( "SELECT templateset_name FROM " . DB_PREFIX . "esselbach_ct_templatesets WHERE templateset_id = '1'" );
		list( $this_templateset ) = $database -> dbrow( $query );
		
		if( $this_templateset != "Default" )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_templatesets SET templateset_name = 'Default' WHERE templateset_id = '1'" );
		}
		
		if( file_exists( $input_module . "/default.tmpl.xml" ) )
		{
			$xml -> importtemplates( $input_module . "/default.tmpl.xml" );
		
			if( $config[ 'ADMIN_LANGUAGE' ] != "en" )
			{
				if( file_exists( $input_module . "/default_de.lang.xml" ) )
				{
					$xml -> importlanguage( $input_module . "/default_de.lang.xml" );
								
					$language_search = array();
					$language_replace = array();
					$query = $database -> dbquery( "SELECT templatelangsnip_search, templatelangsnip_replace FROM " . DB_PREFIX . "esselbach_ct_templateslangsnippets WHERE templatelangsnip_name LIKE '" . $input_module . "%'" );
					
					while( list( $templatelangsnip_search, $templatelangsnip_replace ) = $database -> dbrow( $query ) )
					{
						if( strlen( $templatelangsnip_search ) < 3 )
						{
							$templatelangsnip_search = " " . $templatelangsnip_search . " ";
							$templatelangsnip_replace = " " . $templatelangsnip_replace . " ";
						}
						
						$language_search[ ] = $templatelangsnip_search;
						$language_replace[ ] = $templatelangsnip_replace;
					}
					
					$query = $database -> dbquery( "SELECT template_name, template_html, template_php FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_name LIKE '" . $input_module . "%' AND template_set = '1'" );
					
					while( list( $template_name, $template_html, $template_php ) = $database -> dbrow( $query ) )
					{
						$template_html = str_replace( $language_search, $language_replace, $template_html );
						$template_php = str_replace( $language_search, $language_replace, $template_php );
						$template_name = $database -> dbescape( $template_name );
						$template_html = $database -> dbescape( $template_html );
						$template_php = $database -> dbescape( $template_php );
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_templates SET template_html = '" . $template_html . "', template_php = '" . $template_php . "' WHERE template_name = '" . $template_name . "' AND template_set = '1'" );
					}
				}
			}
		}
		
		if( $this_templateset != "Default" )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_templatesets SET templateset_name = '" . $database -> dbescape( $this_templateset ) . "' WHERE templateset_id = '1'" );
		}
		
		$html -> login( $words_modules[ 'MODULES' ], $words_modules[ 'MODULE_UPDATED' ], "index.php?action=managemodules" );
	}
	else
	{
		$html -> login( $words_modules[ 'ERROR' ], $words_modules[ 'SORRY_INVALID_MODULE' ], "index.php?action=managemodules" );
	}
}
?>